# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`xinetd`](#xinetd): Set up xinetd

### Defined types

* [`xinetd::service`](#xinetd--service): Configure the xinetd service

### Functions

* [`xinetd::validate_log_type`](#xinetd--validate_log_type): Perform validation on the log_type variable, as described in the man page of xinetd.conf(5)

### Data types

* [`Xinetd::AccessTimes`](#Xinetd--AccessTimes): Valid access_times from xinetd.conf(5)
* [`Xinetd::DenyTime`](#Xinetd--DenyTime): Valid deny_time values from xinetd.conf(5)
* [`Xinetd::FailureLogOption`](#Xinetd--FailureLogOption): Valid failure_log_option values from xinetd.conf(5)
* [`Xinetd::Flags`](#Xinetd--Flags): Valid flags values from xinetd.conf(5)
* [`Xinetd::RpcVersion`](#Xinetd--RpcVersion): Valid rpc_version values from xinetd.conf(5)
* [`Xinetd::SocketType`](#Xinetd--SocketType): Valid socket_type values from xinetd.conf(5)
* [`Xinetd::SuccessLogOption`](#Xinetd--SuccessLogOption): Valid success_log_option values from xinetd.conf(5)
* [`Xinetd::Type`](#Xinetd--Type): Valid type values from xinetd.conf(5)
* [`Xinetd::UnlimitedInt`](#Xinetd--UnlimitedInt): Entries that may be either 'UNLIMITED' or an Integer  TODO rlimit_as regex should accept K or M qualifiers

## Classes

### <a name="xinetd"></a>`xinetd`

This is incomplete but should suffice for most purposes.

NOTE: Items prefixed with 'x_' were reserved words in ERB.
* xinetd/xinetd.conf.erb

Explanations of the options can be found in the xinetd.conf(5) man page.

#### Parameters

The following parameters are available in the `xinetd` class:

* [`log_type`](#-xinetd--log_type)
* [`x_bind`](#-xinetd--x_bind)
* [`per_source`](#-xinetd--per_source)
* [`x_umask`](#-xinetd--x_umask)
* [`log_on_success`](#-xinetd--log_on_success)
* [`log_on_failure`](#-xinetd--log_on_failure)
* [`trusted_nets`](#-xinetd--trusted_nets)
* [`no_access`](#-xinetd--no_access)
* [`passenv`](#-xinetd--passenv)
* [`instances`](#-xinetd--instances)
* [`disabled`](#-xinetd--disabled)
* [`disable`](#-xinetd--disable)
* [`enabled`](#-xinetd--enabled)
* [`banner`](#-xinetd--banner)
* [`banner_success`](#-xinetd--banner_success)
* [`banner_fail`](#-xinetd--banner_fail)
* [`groups`](#-xinetd--groups)
* [`cps`](#-xinetd--cps)
* [`max_load`](#-xinetd--max_load)
* [`purge`](#-xinetd--purge)
* [`package_ensure`](#-xinetd--package_ensure)

##### <a name="-xinetd--log_type"></a>`log_type`

Data type: `String[1]`



Default value: `'SYSLOG authpriv'`

##### <a name="-xinetd--x_bind"></a>`x_bind`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-xinetd--per_source"></a>`per_source`

Data type: `Optional[Xinetd::UnlimitedInt]`



Default value: `undef`

##### <a name="-xinetd--x_umask"></a>`x_umask`

Data type: `Optional[Simplib::Umask]`



Default value: `undef`

##### <a name="-xinetd--log_on_success"></a>`log_on_success`

Data type: `Array[Xinetd::SuccessLogOption]`



Default value: `['HOST','PID','DURATION']`

##### <a name="-xinetd--log_on_failure"></a>`log_on_failure`

Data type: `Array[Xinetd::FailureLogOption]`



Default value: `['HOST']`

##### <a name="-xinetd--trusted_nets"></a>`trusted_nets`

Data type: `Simplib::Netlist`



Default value: `lookup('simp_options::trusted_nets', { 'default_value' => ['127.0.0.1', '::1'] })`

##### <a name="-xinetd--no_access"></a>`no_access`

Data type: `Optional[Array[String[1]]]`



Default value: `undef`

##### <a name="-xinetd--passenv"></a>`passenv`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-xinetd--instances"></a>`instances`

Data type: `Xinetd::UnlimitedInt`



Default value: `'60'`

##### <a name="-xinetd--disabled"></a>`disabled`

Data type: `Optional[Array[String[1]]]`



Default value: `undef`

##### <a name="-xinetd--disable"></a>`disable`

Data type: `Optional[Enum['yes','no']]`



Default value: `undef`

##### <a name="-xinetd--enabled"></a>`enabled`

Data type: `Optional[Array[String[1]]]`



Default value: `undef`

##### <a name="-xinetd--banner"></a>`banner`

Data type: `Stdlib::Absolutepath`



Default value: `'/etc/issue.net'`

##### <a name="-xinetd--banner_success"></a>`banner_success`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-xinetd--banner_fail"></a>`banner_fail`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-xinetd--groups"></a>`groups`

Data type: `Enum['yes','no']`



Default value: `'no'`

##### <a name="-xinetd--cps"></a>`cps`

Data type: `Tuple[Integer[1],Integer[1]]`



Default value: `[25,30]`

##### <a name="-xinetd--max_load"></a>`max_load`

Data type: `Optional[Float[0]]`



Default value: `undef`

##### <a name="-xinetd--purge"></a>`purge`

Data type: `Boolean`

Purge all unmanaged services

Default value: `false`

##### <a name="-xinetd--package_ensure"></a>`package_ensure`

Data type: `String[1]`

The ``package`` resource ensure to apply to all included package resources

Default value: `simplib::lookup('simp_options::package_ensure', { 'default_value' => 'installed' })`

## Defined types

### <a name="xinetd--service"></a>`xinetd::service`

For the identification of what these options should be, consult the
xinetd.conf(5) man page.

Items prefixed with 'x_' were reserved words in ERB.
* xinetd/xinetd.service.erb

#### Parameters

The following parameters are available in the `xinetd::service` defined type:

* [`server`](#-xinetd--service--server)
* [`port`](#-xinetd--service--port)
* [`protocol`](#-xinetd--service--protocol)
* [`x_wait`](#-xinetd--service--x_wait)
* [`socket_type`](#-xinetd--service--socket_type)
* [`disable`](#-xinetd--service--disable)
* [`libwrap_name`](#-xinetd--service--libwrap_name)
* [`libwrap`](#-xinetd--service--libwrap)
* [`user`](#-xinetd--service--user)
* [`x_umask`](#-xinetd--service--x_umask)
* [`log_type`](#-xinetd--service--log_type)
* [`log_on_success`](#-xinetd--service--log_on_success)
* [`log_on_failure`](#-xinetd--service--log_on_failure)
* [`x_id`](#-xinetd--service--x_id)
* [`x_type`](#-xinetd--service--x_type)
* [`flags`](#-xinetd--service--flags)
* [`group`](#-xinetd--service--group)
* [`instances`](#-xinetd--service--instances)
* [`nice`](#-xinetd--service--nice)
* [`server_args`](#-xinetd--service--server_args)
* [`trusted_nets`](#-xinetd--service--trusted_nets)
* [`access_times`](#-xinetd--service--access_times)
* [`rpc_version`](#-xinetd--service--rpc_version)
* [`rpc_number`](#-xinetd--service--rpc_number)
* [`env`](#-xinetd--service--env)
* [`passenv`](#-xinetd--service--passenv)
* [`redirect_ip`](#-xinetd--service--redirect_ip)
* [`redirect_port`](#-xinetd--service--redirect_port)
* [`x_bind`](#-xinetd--service--x_bind)
* [`banner`](#-xinetd--service--banner)
* [`banner_success`](#-xinetd--service--banner_success)
* [`banner_fail`](#-xinetd--service--banner_fail)
* [`per_source`](#-xinetd--service--per_source)
* [`cps`](#-xinetd--service--cps)
* [`max_load`](#-xinetd--service--max_load)
* [`groups`](#-xinetd--service--groups)
* [`mdns`](#-xinetd--service--mdns)
* [`enabled`](#-xinetd--service--enabled)
* [`include`](#-xinetd--service--include)
* [`includedir`](#-xinetd--service--includedir)
* [`rlimit_as`](#-xinetd--service--rlimit_as)
* [`rlimit_cpu`](#-xinetd--service--rlimit_cpu)
* [`rlimit_data`](#-xinetd--service--rlimit_data)
* [`rlimit_rss`](#-xinetd--service--rlimit_rss)
* [`rlimit_stack`](#-xinetd--service--rlimit_stack)
* [`deny_time`](#-xinetd--service--deny_time)
* [`firewall`](#-xinetd--service--firewall)
* [`tcpwrappers`](#-xinetd--service--tcpwrappers)

##### <a name="-xinetd--service--server"></a>`server`

Data type: `String`



##### <a name="-xinetd--service--port"></a>`port`

Data type: `Simplib::Port`



##### <a name="-xinetd--service--protocol"></a>`protocol`

Data type: `String`



##### <a name="-xinetd--service--x_wait"></a>`x_wait`

Data type: `Enum['yes','no']`



##### <a name="-xinetd--service--socket_type"></a>`socket_type`

Data type: `Xinetd::SocketType`



##### <a name="-xinetd--service--disable"></a>`disable`

Data type: `Enum['yes','no']`



Default value: `'no'`

##### <a name="-xinetd--service--libwrap_name"></a>`libwrap_name`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-xinetd--service--libwrap"></a>`libwrap`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-xinetd--service--user"></a>`user`

Data type: `String`



Default value: `'root'`

##### <a name="-xinetd--service--x_umask"></a>`x_umask`

Data type: `Simplib::Umask`



Default value: `'027'`

##### <a name="-xinetd--service--log_type"></a>`log_type`

Data type: `String`



Default value: `'SYSLOG authpriv'`

##### <a name="-xinetd--service--log_on_success"></a>`log_on_success`

Data type: `Array[Xinetd::SuccessLogOption]`



Default value: `['HOST','PID','DURATION']`

##### <a name="-xinetd--service--log_on_failure"></a>`log_on_failure`

Data type: `Array[Xinetd::FailureLogOption]`



Default value: `['HOST']`

##### <a name="-xinetd--service--x_id"></a>`x_id`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-xinetd--service--x_type"></a>`x_type`

Data type: `Optional[Xinetd::Type]`



Default value: `undef`

##### <a name="-xinetd--service--flags"></a>`flags`

Data type: `Optional[Array[Xinetd::Flags]]`



Default value: `undef`

##### <a name="-xinetd--service--group"></a>`group`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-xinetd--service--instances"></a>`instances`

Data type: `Optional[Xinetd::UnlimitedInt]`



Default value: `undef`

##### <a name="-xinetd--service--nice"></a>`nice`

Data type: `Optional[Integer]`



Default value: `undef`

##### <a name="-xinetd--service--server_args"></a>`server_args`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-xinetd--service--trusted_nets"></a>`trusted_nets`

Data type: `Simplib::Netlist`



Default value: `simplib::lookup('simp_options::trusted_nets', { 'default_value' => ['127.0.0.1', '::1'] })`

##### <a name="-xinetd--service--access_times"></a>`access_times`

Data type: `Optional[Xinetd::AccessTimes]`



Default value: `undef`

##### <a name="-xinetd--service--rpc_version"></a>`rpc_version`

Data type: `Optional[Xinetd::RpcVersion]`



Default value: `undef`

##### <a name="-xinetd--service--rpc_number"></a>`rpc_number`

Data type: `Optional[Integer]`



Default value: `undef`

##### <a name="-xinetd--service--env"></a>`env`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-xinetd--service--passenv"></a>`passenv`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-xinetd--service--redirect_ip"></a>`redirect_ip`

Data type: `Optional[Simplib::IP]`



Default value: `undef`

##### <a name="-xinetd--service--redirect_port"></a>`redirect_port`

Data type: `Optional[Simplib::Port]`



Default value: `undef`

##### <a name="-xinetd--service--x_bind"></a>`x_bind`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-xinetd--service--banner"></a>`banner`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-xinetd--service--banner_success"></a>`banner_success`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-xinetd--service--banner_fail"></a>`banner_fail`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-xinetd--service--per_source"></a>`per_source`

Data type: `Optional[Xinetd::UnlimitedInt]`



Default value: `undef`

##### <a name="-xinetd--service--cps"></a>`cps`

Data type: `Optional[Tuple[Integer,Integer]]`



Default value: `undef`

##### <a name="-xinetd--service--max_load"></a>`max_load`

Data type: `Optional[Float]`



Default value: `undef`

##### <a name="-xinetd--service--groups"></a>`groups`

Data type: `Optional[Enum['yes','no']]`



Default value: `undef`

##### <a name="-xinetd--service--mdns"></a>`mdns`

Data type: `Optional[Enum['yes','no']]`



Default value: `undef`

##### <a name="-xinetd--service--enabled"></a>`enabled`

Data type: `Optional[Array[String]]`



Default value: `undef`

##### <a name="-xinetd--service--include"></a>`include`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-xinetd--service--includedir"></a>`includedir`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-xinetd--service--rlimit_as"></a>`rlimit_as`

Data type: `Optional[Xinetd::UnlimitedInt]`



Default value: `undef`

##### <a name="-xinetd--service--rlimit_cpu"></a>`rlimit_cpu`

Data type: `Optional[Xinetd::UnlimitedInt]`



Default value: `undef`

##### <a name="-xinetd--service--rlimit_data"></a>`rlimit_data`

Data type: `Optional[Xinetd::UnlimitedInt]`



Default value: `undef`

##### <a name="-xinetd--service--rlimit_rss"></a>`rlimit_rss`

Data type: `Optional[Xinetd::UnlimitedInt]`



Default value: `undef`

##### <a name="-xinetd--service--rlimit_stack"></a>`rlimit_stack`

Data type: `Optional[Xinetd::UnlimitedInt]`



Default value: `undef`

##### <a name="-xinetd--service--deny_time"></a>`deny_time`

Data type: `Optional[Xinetd::DenyTime]`



Default value: `undef`

##### <a name="-xinetd--service--firewall"></a>`firewall`

Data type: `Boolean`

Enable the SIMP firewall module functionality

Default value: `simplib::lookup('simp_options::firewall', { 'default_value' => false })`

##### <a name="-xinetd--service--tcpwrappers"></a>`tcpwrappers`

Data type: `Boolean`

Enable the SIMP tcpwrappers module functionality

Default value: `simplib::lookup('simp_options::tcpwrappers', { 'default_value' => false })`

## Functions

### <a name="xinetd--validate_log_type"></a>`xinetd::validate_log_type`

Type: Ruby 4.x API

Perform validation on the log_type variable, as described in
the man page of xinetd.conf(5)

#### `xinetd::validate_log_type(String $log_type)`

Perform validation on the log_type variable, as described in
the man page of xinetd.conf(5)

Returns: `Any` true upon validation success

Raises:

* `upon` validation failure

##### `log_type`

Data type: `String`

Log specification for xinetd.conf log_type variable

## Data types

### <a name="Xinetd--AccessTimes"></a>`Xinetd::AccessTimes`

Valid access_times from xinetd.conf(5)

Alias of `Pattern[/^([01]?[0-9]|2[0-3]):[0-5][0-9]-([01]?[0-9]|2[0-3]):[0-5][0-9]$/]`

### <a name="Xinetd--DenyTime"></a>`Xinetd::DenyTime`

Valid deny_time values from xinetd.conf(5)

Alias of `Pattern[/^((\d+)|(FOREVER|NEVER))$/]`

### <a name="Xinetd--FailureLogOption"></a>`Xinetd::FailureLogOption`

Valid failure_log_option values from xinetd.conf(5)

Alias of `Enum['HOST', 'USERID', 'ATTEMPT']`

### <a name="Xinetd--Flags"></a>`Xinetd::Flags`

Valid flags values from xinetd.conf(5)

Alias of `Enum['INTERCEPT', 'NORETRY', 'IDONLY', 'NAMEINARGS', 'NODELAY', 'KEEPALIVE', 'NOLIBWRAP', 'SENSOR', 'IPv4', 'IPv6', 'LABELED', 'REUSE']`

### <a name="Xinetd--RpcVersion"></a>`Xinetd::RpcVersion`

Valid rpc_version values from xinetd.conf(5)

Alias of `Pattern[/^\d+(-\d)*$/]`

### <a name="Xinetd--SocketType"></a>`Xinetd::SocketType`

Valid socket_type values from xinetd.conf(5)

Alias of `Enum['stream', 'dgram', 'raw', 'seqpacket']`

### <a name="Xinetd--SuccessLogOption"></a>`Xinetd::SuccessLogOption`

Valid success_log_option values from xinetd.conf(5)

Alias of `Enum['PID', 'HOST', 'USERID', 'EXIT', 'DURATION', 'TRAFFIC']`

### <a name="Xinetd--Type"></a>`Xinetd::Type`

Valid type values from xinetd.conf(5)

Alias of `Enum['RPC', 'INTERNAL', 'TCPMUX', 'TCPMUXPLUS', 'UNLISTED']`

### <a name="Xinetd--UnlimitedInt"></a>`Xinetd::UnlimitedInt`

Entries that may be either 'UNLIMITED' or an Integer

TODO rlimit_as regex should accept K or M qualifiers

Alias of `Variant[Integer, Pattern[/(^\d+$|UNLIMITED)/]]`

